
/*  A Bison parser, made from parse.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	STARTTOK	258
#define	LOADFILE	259
#define	LOADFILE_GLOB	260
#define	NUMBER	261
#define	STRING	262
#define	FUNCID	263
#define	FUNCTION	264
#define	DEFINE	265
#define	CALL	266
#define	RETURNTOK	267
#define	BAILOUT	268
#define	EXCEPTION	269
#define	CONTINUE	270
#define	BREAK	271
#define	WHILE	272
#define	UNTIL	273
#define	FOR	274
#define	DO	275
#define	IF	276
#define	THEN	277
#define	ELSE	278
#define	TO	279
#define	BY	280
#define	IN	281
#define	AT	282
#define	REGION_SEP	283
#define	SEPAR	284
#define	EQUALS	285
#define	EQ_CMP	286
#define	NE_CMP	287
#define	CMP_CMP	288
#define	LT_CMP	289
#define	GT_CMP	290
#define	LE_CMP	291
#define	GE_CMP	292
#define	LOGICAL_XOR	293
#define	LOGICAL_OR	294
#define	LOGICAL_AND	295
#define	LOGICAL_NOT	296
#define	LOWER_THEN_ELSE	297
#define	UMINUS	298

#line 21 "parse.y"

#include <glib.h>
#include <string.h>
#include "structs.h"
#include "mpwrap.h"
#include "eval.h"
#include "dict.h"
#include "util.h"
#include "calc.h"
#include "matrix.h"
#include "matrixw.h"

extern evalstack_t evalstack;

extern int return_ret; /*should the lexer return on \n*/
extern calc_error_t error_num;
extern int got_eof;
extern ETree *free_trees;
extern char *loadfile;
extern char *loadfile_glob;

#define SYNTAX_ERROR {yyerror("syntax error"); YYERROR;}

#define PUSH_ACT(ACT) { \
	ETree *tree = makeoperator(ACT,&evalstack); \
	if(!tree) {SYNTAX_ERROR;} \
	stack_push(&evalstack,tree); \
}

#define PUSH_IDENTIFIER(ID) { \
	ETree * tree; \
	GET_NEW_NODE(tree); \
	tree->type = IDENTIFIER_NODE; \
	tree->data.id = d_intern(ID); \
	tree->args = NULL; \
	tree->nargs = 0; \
	stack_push(&evalstack,tree); \
}

#define PUSH_STRING(ID) { \
	ETree * tree; \
	GET_NEW_NODE(tree); \
	tree->type = STRING_NODE; \
	tree->data.str = ID; \
	tree->args = NULL; \
	tree->nargs = 0; \
	stack_push(&evalstack,tree); \
}

static int
push_func(void)
{
	ETree * tree;
	ETree * val;
	GList * list = NULL;
	int i = 0;
	
	val = stack_pop(&evalstack);
	if(!val)
		return FALSE;


	for(;;) {
		tree = stack_pop(&evalstack);
		if(tree && tree->type==EXPRLIST_START_NODE) {
			freetree(tree);
			break;
		}
		/*we have gone all the way to the top and haven't found a
		  marker or tree is not an ident node*/
		if(!tree || tree->type != IDENTIFIER_NODE) {
			if(tree) freetree(tree);
			g_list_foreach(list,(GFunc)freetree,NULL);
			g_list_free(list); 
			return FALSE;
		}
		list = g_list_prepend(list,tree->data.id);
		freetree(tree);
		i++;
	}
	
	GET_NEW_NODE(tree);

	tree->type = FUNCTION_NODE;
	tree->data.func = d_makeufunc(NULL,val,list,i);
	tree->data.func->context = -1;
	tree->args = NULL;
	tree->nargs = 0;

	stack_push(&evalstack,tree);

	return TRUE;
}

/*pops the last expression, pushes a marker
  entry and puts the last expression back*/
static int
push_marker(ETreeType markertype)
{
	ETree * last_expr = stack_pop(&evalstack);
	ETree * tree;
	
	if(!last_expr)
		return FALSE;
       
	GET_NEW_NODE(tree);
	tree->type = markertype;
	tree->args = NULL;
	tree->nargs = 0;
	stack_push(&evalstack,tree);
	stack_push(&evalstack,last_expr);
	return TRUE;
}

/*pushes a marker*/
static void
push_marker_simple(ETreeType markertype)
{
	ETree *tree;
	GET_NEW_NODE(tree);
	tree->type = markertype;
	tree->args = NULL;
	tree->nargs = 0;
	stack_push(&evalstack,tree);
}

/*puts a spacer into the tree, spacers are just useless nodes to be removed
  before evaluation, they just signify where there were parenthesis*/
static int
push_spacer(void)
{
	ETree * last_expr = stack_pop(&evalstack);
	
	if(!last_expr)
		return FALSE;
	else if(last_expr->type == SPACER_NODE)
		stack_push(&evalstack,last_expr);
	else {
		ETree * tree;
		GET_NEW_NODE(tree);
		tree->type = SPACER_NODE;
		tree->args = g_list_append(NULL,last_expr);
		tree->nargs = 1;
		stack_push(&evalstack,tree);
	}
	return TRUE;
}
	
/*gather all expressions up until a row start marker and push the
  result as a MATRIX_ROW_NODE*/
static int
push_matrix_row(void)
{
	ETree *tree;
	GList *row = NULL;
	int i=0;
	for(;;) {
		tree = stack_pop(&evalstack);
		/*we have gone all the way to the top and haven't found a
		  marker*/
		if(!tree) {
			g_list_foreach(row,(GFunc)freetree,NULL);
			g_list_free(row); 
			return FALSE;
		}
		if(tree->type==EXPRLIST_START_NODE) {
			freetree(tree);
			break;
		}
		row = g_list_prepend(row,tree);
		i++;
	}
	GET_NEW_NODE(tree);
	tree->type = MATRIX_ROW_NODE;
	tree->args = row;
	tree->nargs = i;

	stack_push(&evalstack,tree);
	
	return TRUE;
}
	
/*gather all expressions up until a row start marker and push the
  result as a matrix*/
static int
push_matrix(void)
{
	ETree *tree;
	int i,j;
	int cols,rows;
	GList *rowl = NULL;
	GList *lix,*liy;
	
	Matrix *matrix;
	
	rows=0;
	cols=0;
	for(;;) {
		tree = stack_pop(&evalstack);
		/*we have gone all the way to the top and haven't found a
		  marker*/
		if(!tree) {
			GList *li;
			for(li=rowl;li;li=g_list_next(li)) {
				g_list_foreach(li->data,(GFunc)freetree,
					       NULL);
				g_list_free(li->data); 
			}
			g_list_free(rowl);
			/**/g_warning("BAD MATRIX, NO START MARKER");
			return FALSE;
		} else if(tree->type==MATRIX_START_NODE) {
			freetree(tree);
			break;
		} else if(tree->type==MATRIX_ROW_NODE) {
			if(tree->nargs>cols)
				cols = tree->nargs;
			rowl = g_list_prepend(rowl,tree->args);
			tree->args = NULL;
			tree->nargs = 0;
			freetree(tree);
			rows++;
			continue;
		} else {
			GList *li;
			freetree(tree);
			for(li=rowl;li;li=g_list_next(li)) {
				g_list_foreach(li->data,(GFunc)freetree,
					       NULL);
				g_list_free(li->data); 
			}
			g_list_free(rowl);
			/**/g_warning("BAD MATRIX, A NON ROW ELEMENT FOUND");
			return FALSE;
		}
	}

	matrix = matrix_new();
	matrix_set_size(matrix, cols, rows);
	
	for(j=0,liy=rowl;liy;j++,liy=g_list_next(liy)) {
		for(i=0,lix=liy->data;lix;i++,lix=g_list_next(lix)) {
			matrix_index(matrix,i,j) = lix->data;
		}
		g_list_free(liy->data);
	}
	g_list_free(rowl);
	
	GET_NEW_NODE(tree);
	tree->type = MATRIX_NODE;
	tree->data.matrix = matrixw_new_with_matrix(matrix);
	tree->args = NULL;
	tree->nargs = 0;
	
	stack_push(&evalstack,tree);
	return TRUE;
}

/*pushes a NULL onto the stack, null cannot be evaluated, it will be
  read as ""*/
static void
push_null(void)
{
	ETree *tree;
	GET_NEW_NODE(tree);
	tree->type = NULL_NODE;
	tree->args = NULL;
	tree->nargs = 0;

	stack_push(&evalstack,tree);
}


#line 295 "parse.y"
typedef union {
	mpw_t val;
	char *id;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		197
#define	YYFLAG		-32768
#define	YYNTBASE	65

#define YYTRANSLATE(x) ((unsigned)(x) <= 298 ? yytranslate[x] : 76)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    52,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    49,     2,     2,     2,    47,    59,    48,    53,
    54,    45,    43,    56,    44,    61,    46,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    64,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    57,     2,    58,    50,     2,    60,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    62,    55,    63,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    51
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     8,    12,    15,    20,    23,    25,    29,    34,
    38,    42,    46,    50,    54,    58,    62,    66,    70,    74,
    78,    82,    86,    90,    94,    98,   102,   106,   109,   112,
   115,   118,   122,   129,   136,   143,   150,   156,   162,   168,
   174,   178,   183,   188,   193,   198,   207,   218,   225,   230,
   237,   239,   242,   244,   248,   253,   257,   262,   268,   273,
   277,   280,   284,   287,   290,   293,   295,   297,   299,   301,
   303,   305,   307,   310,   312,   317,   321,   327,   332,   336,
   341,   345,   347,   351,   353,   357,   359
};

static const short yyrhs[] = {     3,
    66,    52,     0,     3,     4,    52,     0,     3,     5,    52,
     0,     3,    52,     0,     3,    66,    29,    52,     0,     1,
    52,     0,     1,     0,    66,    29,    66,     0,    53,    66,
    29,    54,     0,    53,    66,    54,     0,    66,    30,    66,
     0,    55,    66,    55,     0,    66,    43,    66,     0,    66,
    44,    66,     0,    66,    45,    66,     0,    66,    46,    66,
     0,    66,    47,    66,     0,    66,    33,    66,     0,    66,
    31,    66,     0,    66,    32,    66,     0,    66,    34,    66,
     0,    66,    35,    66,     0,    66,    36,    66,     0,    66,
    37,    66,     0,    66,    40,    66,     0,    66,    39,    66,
     0,    66,    38,    66,     0,    41,    66,     0,    66,    49,
     0,    66,    48,     0,    44,    66,     0,    66,    50,    66,
     0,    66,    27,    66,    56,    66,    54,     0,    66,    27,
    75,    56,    66,    54,     0,    66,    27,    66,    56,    75,
    54,     0,    66,    27,    75,    56,    75,    54,     0,    66,
    27,    66,    56,    54,     0,    66,    27,    75,    56,    54,
     0,    66,    27,    56,    66,    54,     0,    66,    27,    56,
    75,    54,     0,    57,    74,    58,     0,    17,    66,    20,
    66,     0,    18,    66,    20,    66,     0,    20,    66,    17,
    66,     0,    20,    66,    18,    66,     0,    19,    68,    30,
    66,    24,    66,    20,    66,     0,    19,    68,    30,    66,
    24,    66,    25,    66,    20,    66,     0,    19,    68,    26,
    66,    20,    66,     0,    21,    66,    22,    66,     0,    21,
    66,    22,    66,    23,    66,     0,    68,     0,    59,    68,
     0,    67,     0,    68,    53,    54,     0,    68,    53,    73,
    54,     0,    67,    53,    54,     0,    67,    53,    73,    54,
     0,    66,    11,    53,    73,    54,     0,    66,    11,    53,
    54,     0,    10,    68,    69,     0,    60,    69,     0,     9,
    68,    70,     0,     9,    70,     0,    60,    70,     0,    12,
    66,     0,    13,     0,    14,     0,    15,     0,    16,     0,
     6,     0,     7,     0,    61,     0,    45,    68,     0,     8,
     0,    53,    72,    54,    71,     0,    53,    54,    71,     0,
    53,    72,    54,    30,    66,     0,    53,    54,    30,    66,
     0,    62,    66,    63,     0,    62,    66,    29,    63,     0,
    72,    56,    68,     0,    68,     0,    73,    56,    66,     0,
    66,     0,    74,    64,    73,     0,    73,     0,    66,    28,
    66,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   349,   350,   351,   352,   353,   354,   355,   358,   359,   361,
   362,   363,   364,   365,   366,   367,   368,   369,   371,   372,
   373,   374,   375,   376,   378,   379,   380,   381,   382,   383,
   384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
   394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
   404,   405,   406,   407,   409,   410,   412,   413,   414,   416,
   417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
   428,   429,   432,   435,   438,   439,   445,   446,   452,   453,
   456,   457,   460,   461,   464,   465,   468
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","STARTTOK",
"LOADFILE","LOADFILE_GLOB","NUMBER","STRING","FUNCID","FUNCTION","DEFINE","CALL",
"RETURNTOK","BAILOUT","EXCEPTION","CONTINUE","BREAK","WHILE","UNTIL","FOR","DO",
"IF","THEN","ELSE","TO","BY","IN","AT","REGION_SEP","SEPAR","EQUALS","EQ_CMP",
"NE_CMP","CMP_CMP","LT_CMP","GT_CMP","LE_CMP","GE_CMP","LOGICAL_XOR","LOGICAL_OR",
"LOGICAL_AND","LOGICAL_NOT","LOWER_THEN_ELSE","'+'","'-'","'*'","'/'","'%'",
"'''","'!'","'^'","UMINUS","'\\n'","'('","')'","'|'","','","'['","']'","'&'",
"'`'","'.'","'{'","'}'","':'","fullexpr","expr","deref","ident","funcdef","funcdef2",
"block","identlist","exprlist","matrixrows","reg", NULL
};
#endif

static const short yyr1[] = {     0,
    65,    65,    65,    65,    65,    65,    65,    66,    66,    66,
    66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
    66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
    66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
    66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
    66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
    66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
    66,    66,    67,    68,    69,    69,    70,    70,    71,    71,
    72,    72,    73,    73,    74,    74,    75
};

static const short yyr2[] = {     0,
     3,     3,     3,     2,     4,     2,     1,     3,     4,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     2,     2,     2,
     2,     3,     6,     6,     6,     6,     5,     5,     5,     5,
     3,     4,     4,     4,     4,     8,    10,     6,     4,     6,
     1,     2,     1,     3,     4,     3,     4,     5,     4,     3,
     2,     3,     2,     2,     2,     1,     1,     1,     1,     1,
     1,     1,     2,     1,     4,     3,     5,     4,     3,     4,
     3,     1,     3,     1,     3,     1,     3
};

static const short yydefact[] = {     0,
     7,     0,     6,     0,     0,    70,    71,    74,     0,     0,
     0,    66,    67,    68,    69,     0,     0,     0,     0,     0,
     0,     0,     0,     4,     0,     0,     0,     0,     0,    72,
     0,    53,    51,     2,     3,     0,     0,    63,     0,    65,
     0,     0,     0,     0,     0,    28,    31,    73,     0,     0,
    84,    86,     0,    52,     0,    61,    64,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    30,    29,     0,     1,
     0,     0,     0,    82,     0,    62,     0,    60,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    10,    12,     0,
    41,     0,     0,     0,     0,     0,     0,     0,     5,     8,
    11,    19,    20,    18,    21,    22,    23,    24,    27,    26,
    25,    13,    14,    15,    16,    17,    32,    56,     0,    54,
     0,     0,     0,     0,     0,     0,    42,    43,     0,     0,
    44,    45,    49,     9,    83,    85,     0,    76,     0,    59,
     0,     0,     0,     0,     0,     0,    57,    55,    78,     0,
    81,     0,     0,     0,     0,     0,    75,    58,    39,    40,
    87,    37,     0,     0,    38,     0,     0,    77,    48,     0,
    50,     0,    79,    33,    35,    34,    36,     0,     0,    80,
    46,     0,     0,    47,     0,     0,     0
};

static const short yydefgoto[] = {   195,
    51,    32,    33,    56,    38,   148,    85,    52,    53,   108
};

static const short yypact[] = {    24,
   -10,   188,-32768,    23,    44,-32768,-32768,-32768,    -4,    92,
   750,-32768,-32768,-32768,-32768,   750,   750,    92,   750,   750,
   750,   750,    92,-32768,   750,   750,   750,    92,    48,-32768,
  1005,    50,    64,-32768,-32768,    -1,    73,-32768,    76,    75,
  1107,  1138,    17,  1045,  1168,  1398,   101,-32768,   975,   855,
  1290,    77,   -18,-32768,     0,-32768,-32768,    78,   302,   358,
   750,   750,   750,   750,   750,   750,   750,   750,   750,   750,
   750,   750,   750,   750,   750,   750,-32768,-32768,   750,-32768,
   414,   470,   102,-32768,   -26,-32768,     2,-32768,   750,   750,
   750,   750,   750,   750,   750,   750,   526,-32768,-32768,   750,
-32768,   750,   -25,    22,   582,   750,   825,    84,-32768,  1350,
  1398,  1446,  1446,  1422,  1446,  1446,  1446,  1446,  1374,  1374,
  1398,    89,    89,   -14,   -14,   -14,    -5,-32768,    25,-32768,
    28,   750,   111,    92,    80,    29,    75,    75,  1199,  1229,
    75,    75,  1320,-32768,  1290,    77,   750,-32768,   -24,-32768,
    43,   885,    90,   750,   638,   694,-32768,-32768,  1398,   750,
-32768,    80,   750,   750,   750,   785,-32768,-32768,-32768,-32768,
  1290,-32768,   915,    93,-32768,   945,    94,  1398,    75,  1076,
    75,   244,-32768,-32768,-32768,-32768,-32768,   750,   750,-32768,
    75,  1260,   750,    75,   143,   146,-32768
};

static const short yypgoto[] = {-32768,
    -2,-32768,    -7,   110,     4,  -123,   -43,   -50,-32768,  -105
};


#define	YYLAST		1496


static const short yytable[] = {    31,
   153,    37,    39,     8,   132,   160,     8,     8,    40,     8,
    43,   104,    59,    41,    42,    48,    44,    45,    46,    47,
    54,    59,    49,    50,     1,   167,     2,   133,    84,   134,
   129,   131,    57,    77,    78,    79,   147,   147,   167,   101,
    86,     3,    92,   136,    79,   102,    93,    84,    36,   174,
   177,   146,    83,   103,   151,   135,   107,   110,   111,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,   126,    34,   149,   127,   134,   157,    84,
   100,   158,   162,   100,   134,-32768,   110,   137,   138,   139,
   140,   141,   142,   143,   110,    35,   168,   145,   100,     8,
    55,    59,    81,   152,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    59,    82,    72,    73,    74,
    75,    76,    77,    78,    79,    36,   161,    59,    87,   159,
   105,   132,   100,    74,    75,    76,    77,    78,    79,   156,
   160,   147,   196,   170,   166,   197,   185,   187,    88,     0,
     0,   171,   173,   176,     0,     0,     0,   178,     0,     0,
   179,   180,   181,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   110,
     0,     0,     0,     0,     0,   191,   192,     0,     0,     0,
   194,     4,     5,     6,     7,     8,     9,    10,     0,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    21,     0,
     0,    22,    23,     0,     0,     0,     0,     0,     0,    24,
    25,     0,    26,     0,    27,     0,    28,    29,    30,     6,
     7,     8,     9,    10,     0,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    21,     0,     0,    22,    23,     0,
     0,     0,     0,     0,     0,     0,    25,     0,    26,     0,
    27,     0,    28,    29,    30,     0,   190,     6,     7,     8,
     9,    10,     0,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    21,     0,     0,    22,    23,     0,     0,     0,
     0,     0,     0,     0,    25,     0,    26,   106,    27,     0,
    28,    29,    30,     6,     7,     8,     9,    10,     0,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    21,     0,
     0,    22,    23,     0,     0,     0,     0,     0,     0,   109,
    25,     0,    26,     0,    27,     0,    28,    29,    30,     6,
     7,     8,     9,    10,     0,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    21,     0,     0,    22,    23,     0,
     0,     0,     0,     0,     0,     0,    25,   128,    26,     0,
    27,     0,    28,    29,    30,     6,     7,     8,     9,    10,
     0,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    21,     0,     0,    22,    23,     0,     0,     0,     0,     0,
     0,     0,    25,   130,    26,     0,    27,     0,    28,    29,
    30,     6,     7,     8,     9,    10,     0,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    21,     0,     0,    22,
    23,     0,     0,     0,     0,     0,     0,     0,    25,   144,
    26,     0,    27,     0,    28,    29,    30,     6,     7,     8,
     9,    10,     0,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    21,     0,     0,    22,    23,     0,     0,     0,
     0,     0,     0,     0,    25,   150,    26,     0,    27,     0,
    28,    29,    30,     6,     7,     8,     9,    10,     0,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    21,     0,
     0,    22,    23,     0,     0,     0,     0,     0,     0,     0,
    25,   172,    26,     0,    27,     0,    28,    29,    30,     6,
     7,     8,     9,    10,     0,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    21,     0,     0,    22,    23,     0,
     0,     0,     0,     0,     0,     0,    25,   175,    26,     0,
    27,     0,    28,    29,    30,     6,     7,     8,     9,    10,
     0,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    21,     0,     0,    22,    23,    58,     0,     0,     0,     0,
     0,     0,    25,     0,    26,     0,    27,     0,    28,    29,
    30,    59,     0,   182,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,     0,     0,    72,    73,    74,
    75,    76,    77,    78,    79,    58,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   183,     0,     0,
     0,    59,   154,    89,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    58,     0,    72,    73,    74,
    75,    76,    77,    78,    79,     0,     0,     0,     0,     0,
   155,    59,     0,    89,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    58,     0,    72,    73,    74,
    75,    76,    77,    78,    79,     0,     0,     0,     0,    99,
     0,    59,   154,    89,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    58,     0,    72,    73,    74,
    75,    76,    77,    78,    79,     0,     0,     0,   169,     0,
     0,    59,   154,    89,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    58,     0,    72,    73,    74,
    75,    76,    77,    78,    79,     0,     0,     0,   184,     0,
     0,    59,   154,    89,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    58,     0,    72,    73,    74,
    75,    76,    77,    78,    79,     0,     0,     0,   186,     0,
     0,    59,     0,    97,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    58,     0,    72,    73,    74,
    75,    76,    77,    78,    79,     0,     0,     0,    98,     0,
     0,    59,     0,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,     0,     0,    72,    73,    74,
    75,    76,    77,    78,    79,    58,    80,     0,     0,     0,
     0,    94,    95,     0,     0,     0,     0,     0,     0,     0,
     0,    59,     0,    89,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,     0,    58,    72,    73,    74,
    75,    76,    77,    78,    79,   188,     0,     0,     0,     0,
   189,     0,    59,     0,    89,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,     0,    58,    72,    73,
    74,    75,    76,    77,    78,    79,    90,     0,     0,     0,
     0,     0,     0,    59,     0,    89,    61,    62,    63,    64,
    65,    66,    67,    68,    69,    70,    71,     0,    58,    72,
    73,    74,    75,    76,    77,    78,    79,    91,     0,     0,
     0,     0,     0,     0,    59,     0,    89,    61,    62,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    58,     0,
    72,    73,    74,    75,    76,    77,    78,    79,     0,    96,
     0,     0,     0,     0,    59,     0,    89,    61,    62,    63,
    64,    65,    66,    67,    68,    69,    70,    71,     0,    58,
    72,    73,    74,    75,    76,    77,    78,    79,   163,     0,
     0,     0,     0,     0,     0,    59,     0,    89,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    58,
     0,    72,    73,    74,    75,    76,    77,    78,    79,     0,
     0,     0,   164,     0,     0,    59,     0,    89,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,     0,
    58,    72,    73,    74,    75,    76,    77,    78,    79,   193,
     0,     0,     0,     0,     0,     0,    59,     0,    89,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    58,     0,    72,    73,    74,    75,    76,    77,    78,    79,
     0,     0,     0,     0,     0,     0,    59,     0,    89,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    58,     0,    72,    73,    74,    75,    76,    77,    78,    79,
     0,     0,   165,     0,     0,     0,    59,     0,     0,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    58,     0,    72,    73,    74,    75,    76,    77,    78,    79,
     0,     0,     0,     0,     0,     0,    59,     0,     0,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
     0,     0,    72,    73,    74,    75,    76,    77,    78,    79,
    59,     0,     0,    61,    62,    63,    64,    65,    66,    67,
    68,     0,     0,    71,     0,     0,    72,    73,    74,    75,
    76,    77,    78,    79,    59,     0,     0,    61,    62,    63,
    64,    65,    66,    67,    68,     0,     0,     0,     0,     0,
    72,    73,    74,    75,    76,    77,    78,    79,    59,     0,
     0,     0,    62,    63,-32768,    65,    66,    67,    68,     0,
     0,     0,     0,     0,    72,    73,    74,    75,    76,    77,
    78,    79,    59,     0,     0,     0,    62,    63,     0,    65,
    66,    67,    68,     0,     0,     0,     0,     0,    72,    73,
    74,    75,    76,    77,    78,    79
};

static const short yycheck[] = {     2,
   106,     9,    10,     8,    30,    30,     8,     8,    11,     8,
    18,    55,    27,    16,    17,    23,    19,    20,    21,    22,
    28,    27,    25,    26,     1,   149,     3,    54,    36,    56,
    81,    82,    29,    48,    49,    50,    62,    62,   162,    58,
    37,    52,    26,    87,    50,    64,    30,    55,    53,   155,
   156,   102,    54,    54,   105,    54,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    52,    54,    79,    56,    54,    87,
    56,    54,    54,    56,    56,    11,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    52,    54,   100,    56,     8,
    53,    27,    53,   106,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    27,    53,    43,    44,    45,
    46,    47,    48,    49,    50,    53,   134,    27,    53,   132,
    53,    30,    56,    45,    46,    47,    48,    49,    50,    56,
    30,    62,     0,    54,   147,     0,    54,    54,    39,    -1,
    -1,   154,   155,   156,    -1,    -1,    -1,   160,    -1,    -1,
   163,   164,   165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   182,
    -1,    -1,    -1,    -1,    -1,   188,   189,    -1,    -1,    -1,
   193,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,
    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
    53,    -1,    55,    -1,    57,    -1,    59,    60,    61,     6,
     7,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    41,    -1,    -1,    44,    45,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    53,    -1,    55,    -1,
    57,    -1,    59,    60,    61,    -1,    63,     6,     7,     8,
     9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    53,    -1,    55,    56,    57,    -1,
    59,    60,    61,     6,     7,     8,     9,    10,    -1,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,
    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
    53,    -1,    55,    -1,    57,    -1,    59,    60,    61,     6,
     7,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    41,    -1,    -1,    44,    45,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    53,    54,    55,    -1,
    57,    -1,    59,    60,    61,     6,     7,     8,     9,    10,
    -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    53,    54,    55,    -1,    57,    -1,    59,    60,
    61,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    44,
    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    53,    54,
    55,    -1,    57,    -1,    59,    60,    61,     6,     7,     8,
     9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    53,    54,    55,    -1,    57,    -1,
    59,    60,    61,     6,     7,     8,     9,    10,    -1,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,
    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    53,    54,    55,    -1,    57,    -1,    59,    60,    61,     6,
     7,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    41,    -1,    -1,    44,    45,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    53,    54,    55,    -1,
    57,    -1,    59,    60,    61,     6,     7,     8,     9,    10,
    -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    41,    -1,    -1,    44,    45,    11,    -1,    -1,    -1,    -1,
    -1,    -1,    53,    -1,    55,    -1,    57,    -1,    59,    60,
    61,    27,    -1,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
    46,    47,    48,    49,    50,    11,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,
    -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    11,    -1,    43,    44,    45,
    46,    47,    48,    49,    50,    -1,    -1,    -1,    -1,    -1,
    56,    27,    -1,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    11,    -1,    43,    44,    45,
    46,    47,    48,    49,    50,    -1,    -1,    -1,    -1,    55,
    -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    11,    -1,    43,    44,    45,
    46,    47,    48,    49,    50,    -1,    -1,    -1,    54,    -1,
    -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    11,    -1,    43,    44,    45,
    46,    47,    48,    49,    50,    -1,    -1,    -1,    54,    -1,
    -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    11,    -1,    43,    44,    45,
    46,    47,    48,    49,    50,    -1,    -1,    -1,    54,    -1,
    -1,    27,    -1,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    11,    -1,    43,    44,    45,
    46,    47,    48,    49,    50,    -1,    -1,    -1,    54,    -1,
    -1,    27,    -1,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
    46,    47,    48,    49,    50,    11,    52,    -1,    -1,    -1,
    -1,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    27,    -1,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    -1,    11,    43,    44,    45,
    46,    47,    48,    49,    50,    20,    -1,    -1,    -1,    -1,
    25,    -1,    27,    -1,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    -1,    11,    43,    44,
    45,    46,    47,    48,    49,    50,    20,    -1,    -1,    -1,
    -1,    -1,    -1,    27,    -1,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    39,    40,    -1,    11,    43,
    44,    45,    46,    47,    48,    49,    50,    20,    -1,    -1,
    -1,    -1,    -1,    -1,    27,    -1,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    11,    -1,
    43,    44,    45,    46,    47,    48,    49,    50,    -1,    22,
    -1,    -1,    -1,    -1,    27,    -1,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    -1,    11,
    43,    44,    45,    46,    47,    48,    49,    50,    20,    -1,
    -1,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    11,
    -1,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
    -1,    -1,    24,    -1,    -1,    27,    -1,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
    11,    43,    44,    45,    46,    47,    48,    49,    50,    20,
    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    11,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    11,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
    -1,    -1,    23,    -1,    -1,    -1,    27,    -1,    -1,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    11,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    -1,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
    27,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
    37,    -1,    -1,    40,    -1,    -1,    43,    44,    45,    46,
    47,    48,    49,    50,    27,    -1,    -1,    30,    31,    32,
    33,    34,    35,    36,    37,    -1,    -1,    -1,    -1,    -1,
    43,    44,    45,    46,    47,    48,    49,    50,    27,    -1,
    -1,    -1,    31,    32,    33,    34,    35,    36,    37,    -1,
    -1,    -1,    -1,    -1,    43,    44,    45,    46,    47,    48,
    49,    50,    27,    -1,    -1,    -1,    31,    32,    -1,    34,
    35,    36,    37,    -1,    -1,    -1,    -1,    -1,    43,    44,
    45,    46,    47,    48,    49,    50
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 349 "parse.y"
{ YYACCEPT; ;
    break;}
case 2:
#line 350 "parse.y"
{ loadfile = yyvsp[-1].id; YYACCEPT; ;
    break;}
case 3:
#line 351 "parse.y"
{ loadfile_glob = yyvsp[-1].id; YYACCEPT; ;
    break;}
case 4:
#line 352 "parse.y"
{ YYACCEPT; ;
    break;}
case 5:
#line 353 "parse.y"
{ push_null(); PUSH_ACT(E_SEPAR); YYACCEPT; ;
    break;}
case 6:
#line 354 "parse.y"
{ return_ret = TRUE; yyclearin; YYABORT; ;
    break;}
case 7:
#line 355 "parse.y"
{ return_ret = TRUE; ;
    break;}
case 8:
#line 358 "parse.y"
{ PUSH_ACT(E_SEPAR); ;
    break;}
case 9:
#line 359 "parse.y"
{ push_null(); PUSH_ACT(E_SEPAR);
					  push_spacer(); ;
    break;}
case 10:
#line 361 "parse.y"
{ push_spacer(); ;
    break;}
case 11:
#line 362 "parse.y"
{ PUSH_ACT(E_EQUALS); ;
    break;}
case 12:
#line 363 "parse.y"
{ PUSH_ACT(E_ABS); ;
    break;}
case 13:
#line 364 "parse.y"
{ PUSH_ACT(E_PLUS); ;
    break;}
case 14:
#line 365 "parse.y"
{ PUSH_ACT(E_MINUS); ;
    break;}
case 15:
#line 366 "parse.y"
{ PUSH_ACT(E_MUL); ;
    break;}
case 16:
#line 367 "parse.y"
{ PUSH_ACT(E_DIV); ;
    break;}
case 17:
#line 368 "parse.y"
{ PUSH_ACT(E_MOD); ;
    break;}
case 18:
#line 369 "parse.y"
{ PUSH_ACT(E_CMP_CMP); ;
    break;}
case 19:
#line 371 "parse.y"
{ PUSH_ACT(E_EQ_CMP); ;
    break;}
case 20:
#line 372 "parse.y"
{ PUSH_ACT(E_NE_CMP); ;
    break;}
case 21:
#line 373 "parse.y"
{ PUSH_ACT(E_LT_CMP); ;
    break;}
case 22:
#line 374 "parse.y"
{ PUSH_ACT(E_GT_CMP); ;
    break;}
case 23:
#line 375 "parse.y"
{ PUSH_ACT(E_LE_CMP); ;
    break;}
case 24:
#line 376 "parse.y"
{ PUSH_ACT(E_GE_CMP); ;
    break;}
case 25:
#line 378 "parse.y"
{ PUSH_ACT(E_LOGICAL_AND); ;
    break;}
case 26:
#line 379 "parse.y"
{ PUSH_ACT(E_LOGICAL_OR); ;
    break;}
case 27:
#line 380 "parse.y"
{ PUSH_ACT(E_LOGICAL_XOR); ;
    break;}
case 28:
#line 381 "parse.y"
{ PUSH_ACT(E_LOGICAL_NOT); ;
    break;}
case 29:
#line 382 "parse.y"
{ PUSH_ACT(E_FACT); ;
    break;}
case 30:
#line 383 "parse.y"
{ PUSH_ACT(E_TRANSPOSE); ;
    break;}
case 31:
#line 384 "parse.y"
{ PUSH_ACT(E_NEG); ;
    break;}
case 32:
#line 385 "parse.y"
{ PUSH_ACT(E_EXP); ;
    break;}
case 33:
#line 386 "parse.y"
{ PUSH_ACT(E_GET_ELEMENT); ;
    break;}
case 34:
#line 387 "parse.y"
{ PUSH_ACT(E_GET_REGION); ;
    break;}
case 35:
#line 388 "parse.y"
{ PUSH_ACT(E_GET_REGION); ;
    break;}
case 36:
#line 389 "parse.y"
{ PUSH_ACT(E_GET_REGION); ;
    break;}
case 37:
#line 390 "parse.y"
{ PUSH_ACT(E_GET_ROW_REGION); ;
    break;}
case 38:
#line 391 "parse.y"
{ PUSH_ACT(E_GET_ROW_REGION); ;
    break;}
case 39:
#line 392 "parse.y"
{ PUSH_ACT(E_GET_COL_REGION); ;
    break;}
case 40:
#line 393 "parse.y"
{ PUSH_ACT(E_GET_COL_REGION); ;
    break;}
case 41:
#line 394 "parse.y"
{ if(!push_matrix()) {SYNTAX_ERROR;} ;
    break;}
case 42:
#line 395 "parse.y"
{ PUSH_ACT(E_WHILE_CONS); ;
    break;}
case 43:
#line 396 "parse.y"
{ PUSH_ACT(E_UNTIL_CONS); ;
    break;}
case 44:
#line 397 "parse.y"
{ PUSH_ACT(E_DOWHILE_CONS); ;
    break;}
case 45:
#line 398 "parse.y"
{ PUSH_ACT(E_DOUNTIL_CONS); ;
    break;}
case 46:
#line 399 "parse.y"
{ PUSH_ACT(E_FOR_CONS); ;
    break;}
case 47:
#line 400 "parse.y"
{ PUSH_ACT(E_FORBY_CONS); ;
    break;}
case 48:
#line 401 "parse.y"
{ PUSH_ACT(E_FORIN_CONS); ;
    break;}
case 49:
#line 402 "parse.y"
{ PUSH_ACT(E_IF_CONS); ;
    break;}
case 50:
#line 403 "parse.y"
{ PUSH_ACT(E_IFELSE_CONS); ;
    break;}
case 52:
#line 405 "parse.y"
{ PUSH_ACT(E_REFERENCE); ;
    break;}
case 54:
#line 407 "parse.y"
{ push_marker_simple(EXPRLIST_START_NODE);
					  PUSH_ACT(E_DIRECTCALL); ;
    break;}
case 55:
#line 409 "parse.y"
{ PUSH_ACT(E_DIRECTCALL); ;
    break;}
case 56:
#line 410 "parse.y"
{ push_marker_simple(EXPRLIST_START_NODE);
					  PUSH_ACT(E_CALL); ;
    break;}
case 57:
#line 412 "parse.y"
{ PUSH_ACT(E_CALL); ;
    break;}
case 58:
#line 413 "parse.y"
{ PUSH_ACT(E_CALL); ;
    break;}
case 59:
#line 414 "parse.y"
{ push_marker_simple(EXPRLIST_START_NODE);
					  PUSH_ACT(E_CALL); ;
    break;}
case 60:
#line 416 "parse.y"
{ PUSH_ACT(E_EQUALS); ;
    break;}
case 62:
#line 418 "parse.y"
{ PUSH_ACT(E_EQUALS); ;
    break;}
case 65:
#line 421 "parse.y"
{ PUSH_ACT(E_RETURN); ;
    break;}
case 66:
#line 422 "parse.y"
{ PUSH_ACT(E_BAILOUT); ;
    break;}
case 67:
#line 423 "parse.y"
{ PUSH_ACT(E_EXCEPTION); ;
    break;}
case 68:
#line 424 "parse.y"
{ PUSH_ACT(E_CONTINUE); ;
    break;}
case 69:
#line 425 "parse.y"
{ PUSH_ACT(E_BREAK); ;
    break;}
case 70:
#line 426 "parse.y"
{ stack_push(&evalstack,
						     makenum_use(yyvsp[0].val)); ;
    break;}
case 71:
#line 428 "parse.y"
{ PUSH_STRING(yyvsp[0].id); ;
    break;}
case 72:
#line 429 "parse.y"
{ push_null(); ;
    break;}
case 73:
#line 432 "parse.y"
{ PUSH_ACT(E_DEREFERENCE); ;
    break;}
case 74:
#line 435 "parse.y"
{ PUSH_IDENTIFIER(yyvsp[0].id); g_free(yyvsp[0].id); ;
    break;}
case 75:
#line 438 "parse.y"
{ if(!push_func()) {SYNTAX_ERROR;} ;
    break;}
case 76:
#line 439 "parse.y"
{ if(!push_marker(EXPRLIST_START_NODE))
						{SYNTAX_ERROR;}
					  if(!push_func())
					  	{SYNTAX_ERROR;} ;
    break;}
case 77:
#line 445 "parse.y"
{ if(!push_func()) {SYNTAX_ERROR;} ;
    break;}
case 78:
#line 446 "parse.y"
{ if(!push_marker(EXPRLIST_START_NODE))
						{SYNTAX_ERROR;}
					  if(!push_func())
					  	{SYNTAX_ERROR;} ;
    break;}
case 80:
#line 453 "parse.y"
{ push_null(); PUSH_ACT(E_SEPAR); ;
    break;}
case 82:
#line 457 "parse.y"
{ if(!push_marker(EXPRLIST_START_NODE)) {SYNTAX_ERROR;} ;
    break;}
case 84:
#line 461 "parse.y"
{ if(!push_marker(EXPRLIST_START_NODE)) {SYNTAX_ERROR;} ;
    break;}
case 85:
#line 464 "parse.y"
{ if(!push_matrix_row()) {SYNTAX_ERROR;} ;
    break;}
case 86:
#line 465 "parse.y"
{ if(!push_matrix_row()) {SYNTAX_ERROR;} if(!push_marker(MATRIX_START_NODE)) {SYNTAX_ERROR;} ;
    break;}
case 87:
#line 468 "parse.y"
{ PUSH_ACT(E_REGION_SEP); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 471 "parse.y"

